const fs = require("fs-extra")
const download = require("download-git-repo")
const os = require("os")
const path = require("path")

const config = require("../config/config")
const { remotePresetMap } = config

const loadRemotePreset = async function (name, targetDir, clone) {
  const tmpdir = path.join(os.tmpdir(), name)

  await fs.remove(tmpdir) // 下载前删除临时文件

  await new Promise((resolve, reject) => {
    download(
      remotePresetMap[name],
      tmpdir,
      {
        clone
      },
      err => {
        if (err) return reject(err)
        resolve()
      }
    )
  })

  return {
    targetDir,
    tmpdir
  }
}

module.exports = loadRemotePreset
