var socket = io("http://localhost:8087")
socket.on("warn", count => {
  console.log("warning count : " + count)
})

var App = {
  data() {
    return {
      activeName: 1,//当前展开项目模版索引
      loadingIns: null,
      dialogVisible: false,
      fileName: "", // 文件名称
      selectTemplate: null,
      projectShow: false,
      projectFileName: "", // 项目名称
      selectProject: null, // 选择的项目名称
      projectList: [],
      templateList: []
    }
  },
  setup() {

  },
  create() {

  },
  mounted() {
    $.get("./data/templateList.json", (data) => {
      this.templateList = data
    })
    $.get("./data/projectModel.json", (data) => {
      this.projectList = data
    })
  },
  methods: {
    openWindow(url) {
      window.open(url, "_blank")
    },

    handleOpen(key, ketPath) {
      console.log(key)
    },

    // 下载项目
    handleShowProject(v) {
      this.projectShow = true
      this.selectProject = v
      this.projectFileName = ""
    },

    // 下载项目
    downloadProject(v) {
      try {
        this.loadingIns = this.$loading({
          text: "下载中..."
        })
        var project = this.selectProject
        var projectFileName = this.projectFileName
        var params = {
          name: project.name,
          origin: project.downLoadUrl,
          projectFileName: projectFileName
        }
        socket.emit("downloadProject", params)
      } catch (error) {
        this.loadingIns.close()
      }
    },

    // 下载组件
    handleCreate(v) {
      this.dialogVisible = true
      this.selectTemplate = v
      this.fileName = ""
    },

    requireExecute() {
      this.loadingIns = this.$loading({
        text: "下载中..."
      })
      try {
        let template = this.selectTemplate
        var name = template.name
        var value = template.value
        var files = template.files
        var fileName = this.fileName
        if (!fileName) {
          this.warning({
            message: "请输入文件名称",
            type: "warning"
          })
        }
        var params = {
          name: name,
          value: value,
          files: files,
          fileName: fileName
        }
        socket.emit("handle", params)
      } catch (error) {
        this.loadingIns.close()
      }
    }
  }
}

const app = Vue.createApp(App)
// eslint-disable-next-line no-undef
app.use(ElementPlus)
const vm = app.mount("#app")

socket.on("serverMsg", msg => {
  var data = msg.msg
  if (vm.$data.loadingIns) {
    vm.$data.loadingIns.close()
  }
  if (data.code === 200) {
    vm.$data.dialogVisible = false
    vm.$data.projectShow = false // 关闭下载项目弹窗
    vm.$notify({
      title: "成功",
      message: "创建成功：" + data.data,
      type: "success"
    })
  } else {
    vm.$notify.error({
      title: "错误",
      message: data.message,
      type: "success"
    })
  }
})
