const fs = require("fs-extra")
const download = require("download-git-repo")
const os = require("os")
const path = require("path")

const loadRemotePreset = async function (origin, clone) {
  const tmpdir = path.join(os.tmpdir(), "gyProjectTemplateTemp")
  await fs.remove(tmpdir) // 下载前删除临时文件
  origin = origin.replace(/(^\s*)|(\s*$)/g, "")
  await new Promise((resolve, reject) => {
    download(
      origin,
      tmpdir,
      {
        clone
      },
      err => {
        if (err) return reject(err)
        resolve()
      }
    )
  })
  return {
    tmpdir,
  }
}

module.exports = loadRemotePreset
